--- session.c.orig	Tue Mar 18 11:57:20 2008
+++ session.c	Tue Mar 18 12:02:55 2008
@@ -838,6 +838,7 @@ int GetWindowConfig (TwmWindow *theWindow, short *x, s
     return found;
 }
 
+#ifndef __OpenBSD__
 /*===[ Unique Filename Generator ]===========================================*/
 
 static char *unique_filename (char *path, char *prefix)
@@ -865,6 +866,7 @@ static char *unique_filename (char *path, char *prefix
 #endif
 }
 
+#endif /* ! __OpenBSD__ */
 /*===[ SAVE WINDOW INFORMATION ]=============================================*/
 
 #ifndef PATH_MAX
@@ -890,6 +892,10 @@ void SaveYourselfPhase2CB (SmcConn smcCon, SmPointer c
     SmPropValue prop1val, prop2val, prop3val;
     char discardCommand[PATH_MAX + 4];
     int numVals, i;
+#ifdef __OpenBSD__
+    int tmphandle;
+    char tmpprefix[256];
+#endif
     static int first_time = 1;
 
     if (first_time)
@@ -942,12 +948,20 @@ void SaveYourselfPhase2CB (SmcConn smcCon, SmPointer c
      *        no longer the same since the new format supports
      *        virtaul workspaces.
      *========================================================*/
+#ifdef __OpenBSD__
+    strlcpy(tmpprefix, path, 256);
+    strlcat(tmpprefix, "/.ctwmXXXXXX", (sizeof(path) - 12));
+    if ((tmphandle = mkstemp(tmpprefix)) == -1)
+        goto bad;
+    if ((configFile = fdopen(tmphandle, "wb")) == NULL)
+        goto bad;
+#else
     if ((filename = unique_filename (path, ".ctwm")) == NULL)
 	goto bad;
 
     if (!(configFile = fopen (filename, "wb"))) /* wb = write bytes ? */
 	goto bad;
-
+#endif /* __OpenBSD__ */
     if (!write_ushort (configFile, SAVEFILE_VERSION))
 	goto bad;
 
